
############# Target type (Debug/Release) ##################
############################################################
CPPCompileDebug=-g
CPPCompileRelease=-O
LinkDebug=-g
LinkRelease=-O

ConfigurationCPPCompileSwitches=   -I. -I$(OMROOT) -I$(OMROOT)/LangCpp -I$(OMROOT)/LangCpp/oxf -D_OM_NO_IOSTREAM -DCYGWIN $(INST_FLAGS) $(INCLUDE_PATH) $(INST_INCLUDES) $(CPPCompileDebug) -c

#########################################
###### Predefined macros ################
RM=/bin/rm -rf
INCLUDE_QUALIFIER=-I
CC=gcc
LIB_CMD=ar
LINK_CMD=g++
LIB_FLAGS=rvu
LINK_FLAGS= $(LinkDebug)  

#########################################
####### Context macros ##################

FLAGSFILE=
RULESFILE=
OMROOT="D:/Rhapsody6.1/Share"

CPP_EXT=.cpp
H_EXT=.h
OBJ_EXT=.o
EXE_EXT=.exe
LIB_EXT=.a

INSTRUMENTATION=Animation

TIME_MODEL=Simulated

TARGET_TYPE=Executable

TARGET_NAME=DefaultComponent

all : $(TARGET_NAME)$(EXE_EXT) DefaultComponent.mak

TARGET_MAIN=MainDefaultComponent

LIBS=

INCLUDE_PATH= \
  $(INCLUDE_QUALIFIER)$(OMROOT)/LangCpp/osconfig/Cygwin

ADDITIONAL_OBJS=

OBJS= \
  architectureSIP.o \
  Initiator_and_dns.o \
  iDNSLookupInitRes.o \
  iDNSLookupResInit.o \
  SIP_Redirect.o \
  SIP_terminal.o \
  sip.o




#########################################
####### Predefined macros ###############
$(OBJS) :  $(INST_LIBS) $(OXF_LIBS)

ifeq ($(INSTRUMENTATION),Animation)

INST_FLAGS=-DOMANIMATOR -D__USE_W32_SOCKETS
INST_INCLUDES=-I$(OMROOT)/LangCpp/aom -I$(OMROOT)/LangCpp/tom
INST_LIBS= $(OMROOT)/LangCpp/lib/cygwinaomanim$(LIB_EXT)
OXF_LIBS=$(OMROOT)/LangCpp/lib/cygwinoxfinst$(LIB_EXT) $(OMROOT)/LangCpp/lib/cygwinomcomappl$(LIB_EXT)
SOCK_LIB=-lws2_32 

else
ifeq ($(INSTRUMENTATION),Tracing)

INST_FLAGS=-DOMTRACER
INST_INCLUDES=-I$(OMROOT)/LangCpp/aom -I$(OMROOT)/LangCpp/tom
INST_LIBS=$(OMROOT)/LangCpp/lib/cygwintomtrace$(LIB_EXT) $(OMROOT)/LangCpp/lib/cygwinaomtrace$(LIB_EXT)
OXF_LIBS= $(OMROOT)/LangCpp/lib/cygwinoxfinst$(LIB_EXT) $(OMROOT)/LangCpp/lib/cygwinomcomappl$(LIB_EXT)
SOCK_LIB=-lws2_32 

else
ifeq ($(INSTRUMENTATION),None)

INST_FLAGS=
INST_INCLUDES=
INST_LIBS=
OXF_LIBS=$(OMROOT)/LangCpp/lib/cygwinoxf$(LIB_EXT)
SOCK_LIB=-lws2_32

else
	@echo An invalid Instrumentation $(INSTRUMENTATION) is specified.
	exit
endif
endif
endif

.SUFFIXES: $(CPP_EXT)

#####################################################################
##################### Context dependencies and commands #############






architectureSIP.o : architectureSIP.cpp architectureSIP.h    sip.h Initiator_and_dns.h SIP_Redirect.h SIP_terminal.h iDNSLookupInitRes.h iDNSLookupResInit.h 
	@echo Compiling architectureSIP.cpp
	@$(CC) $(ConfigurationCPPCompileSwitches)  -o architectureSIP.o architectureSIP.cpp




Initiator_and_dns.o : Initiator_and_dns.cpp Initiator_and_dns.h    sip.h iDNSLookupResInit.h iDNSLookupInitRes.h 
	@echo Compiling Initiator_and_dns.cpp
	@$(CC) $(ConfigurationCPPCompileSwitches)  -o Initiator_and_dns.o Initiator_and_dns.cpp




iDNSLookupInitRes.o : iDNSLookupInitRes.cpp iDNSLookupInitRes.h    sip.h 
	@echo Compiling iDNSLookupInitRes.cpp
	@$(CC) $(ConfigurationCPPCompileSwitches)  -o iDNSLookupInitRes.o iDNSLookupInitRes.cpp




iDNSLookupResInit.o : iDNSLookupResInit.cpp iDNSLookupResInit.h    sip.h 
	@echo Compiling iDNSLookupResInit.cpp
	@$(CC) $(ConfigurationCPPCompileSwitches)  -o iDNSLookupResInit.o iDNSLookupResInit.cpp




SIP_Redirect.o : SIP_Redirect.cpp SIP_Redirect.h    sip.h iDNSLookupInitRes.h iDNSLookupResInit.h 
	@echo Compiling SIP_Redirect.cpp
	@$(CC) $(ConfigurationCPPCompileSwitches)  -o SIP_Redirect.o SIP_Redirect.cpp




SIP_terminal.o : SIP_terminal.cpp SIP_terminal.h    sip.h iDNSLookupInitRes.h iDNSLookupResInit.h 
	@echo Compiling SIP_terminal.cpp
	@$(CC) $(ConfigurationCPPCompileSwitches)  -o SIP_terminal.o SIP_terminal.cpp




sip.o : sip.cpp sip.h    SIP_terminal.h SIP_Redirect.h Initiator_and_dns.h iDNSLookupInitRes.h iDNSLookupResInit.h architectureSIP.h 
	@echo Compiling sip.cpp
	@$(CC) $(ConfigurationCPPCompileSwitches)  -o sip.o sip.cpp







$(TARGET_MAIN)$(OBJ_EXT) : $(TARGET_MAIN)$(CPP_EXT) $(OBJS)
	@echo Compiling $(TARGET_MAIN)$(CPP_EXT)
	@$(CC) $(ConfigurationCPPCompileSwitches) -o  $(TARGET_MAIN)$(OBJ_EXT) $(TARGET_MAIN)$(CPP_EXT)

####################################################################
############## Predefined Instructions #############################
$(TARGET_NAME)$(EXE_EXT): $(OBJS) $(ADDITIONAL_OBJS) $(TARGET_MAIN)$(OBJ_EXT) DefaultComponent.mak
	@echo Linking $(TARGET_NAME)$(EXE_EXT)
	@$(LINK_CMD)  $(TARGET_MAIN)$(OBJ_EXT) $(OBJS) $(ADDITIONAL_OBJS) \
	$(LIBS) \
	$(INST_LIBS) \
	$(OXF_LIBS) \
	$(INST_LIBS) \
	$(SOCK_LIB) \
	$(LINK_FLAGS) -o $(TARGET_NAME)$(EXE_EXT)

$(TARGET_NAME)$(LIB_EXT) : $(OBJS) $(ADDITIONAL_OBJS) DefaultComponent.mak
	@echo Building library $@
	@$(LIB_CMD) $(LIB_FLAGS) $(TARGET_NAME)$(LIB_EXT) $(OBJS) $(ADDITIONAL_OBJS)



clean:
	@echo Cleanup
	$(RM) architectureSIP.o
	$(RM) Initiator_and_dns.o
	$(RM) iDNSLookupInitRes.o
	$(RM) iDNSLookupResInit.o
	$(RM) SIP_Redirect.o
	$(RM) SIP_terminal.o
	$(RM) sip.o
	$(RM) $(TARGET_MAIN)$(OBJ_EXT) $(ADDITIONAL_OBJS)
	$(RM) $(TARGET_NAME)$(LIB_EXT)
	$(RM) $(TARGET_NAME)$(EXE_EXT)

