/********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: architectureSIP
//!	Generated Date	: Wed, 19, Apr 2006  
	File Path	: DefaultComponent/DefaultConfig/architectureSIP.cpp
*********************************************************************/


//#[ ignore 
#define NAMESPACE_PREFIX 
//#]

#include "architectureSIP.h"

//## package sip 


//#[ ignore 
#define sip_architectureSIP_architectureSIP_SERIALIZE OM_NO_OP
//#]

//----------------------------------------------------------------------------
// architectureSIP.cpp                                                                  
//----------------------------------------------------------------------------
DECLARE_META_PACKAGE(sip)
//## class architectureSIP 



architectureSIP::architectureSIP(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(architectureSIP, architectureSIP(), 0, sip_architectureSIP_architectureSIP_SERIALIZE);
    setActiveContext(theActiveContext, false);
    {
        {
            initiator_and_dns.setShouldDelete(false);
        }
        initiator_and_dns.setActiveContext(theActiveContext, false);
        {
            sip_Redirect.setShouldDelete(false);
        }
        sip_Redirect.setActiveContext(theActiveContext, false);
        {
            B_home_terminal.setShouldDelete(false);
        }
        B_home_terminal.setActiveContext(theActiveContext, false);
        {
            C_terminal.setShouldDelete(false);
        }
        C_terminal.setActiveContext(theActiveContext, false);
        {
            B_work_terminal.setShouldDelete(false);
        }
        B_work_terminal.setActiveContext(theActiveContext, false);
        {
            A_terminal.setShouldDelete(false);
        }
        A_terminal.setActiveContext(theActiveContext, false);
    }
    initRelations();
}

architectureSIP::~architectureSIP() {
    NOTIFY_DESTRUCTOR(~architectureSIP, true);
}

SIP_terminal* architectureSIP::getA_terminal() const {
    return (SIP_terminal*) &A_terminal;
}

SIP_terminal* architectureSIP::getB_home_terminal() const {
    return (SIP_terminal*) &B_home_terminal;
}

SIP_terminal* architectureSIP::getB_work_terminal() const {
    return (SIP_terminal*) &B_work_terminal;
}

SIP_terminal* architectureSIP::getC_terminal() const {
    return (SIP_terminal*) &C_terminal;
}

Initiator_and_dns* architectureSIP::getInitiator_and_dns() const {
    return (Initiator_and_dns*) &initiator_and_dns;
}

SIP_Redirect* architectureSIP::getSip_Redirect() const {
    return (SIP_Redirect*) &sip_Redirect;
}

void architectureSIP::destroy() {
    A_terminal.destroy();
    B_home_terminal.destroy();
    B_work_terminal.destroy();
    C_terminal.destroy();
    initiator_and_dns.destroy();
    sip_Redirect.destroy();
    OMReactive::destroy();
}

void architectureSIP::initRelations() {
    {
    	
    	sip_Redirect.getPDNS()->setItsIDNSLookupInitRes(initiator_and_dns.getPDNSServer()->getItsIDNSLookupInitRes());
    	
    }{
    	
    	initiator_and_dns.getPDNSServer()->setItsIDNSLookupResInit(sip_Redirect.getPDNS()->getItsIDNSLookupResInit());
    	
    }
    {
    	
    	sip_Redirect.getPC()->setItsDefaultRequiredInterface(C_terminal.getPServer()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	C_terminal.getPServer()->setItsDefaultRequiredInterface(sip_Redirect.getPC()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	sip_Redirect.getPBw()->setItsDefaultRequiredInterface(B_work_terminal.getPServer()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	B_work_terminal.getPServer()->setItsDefaultRequiredInterface(sip_Redirect.getPBw()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	sip_Redirect.getPBh()->setItsDefaultRequiredInterface(B_home_terminal.getPServer()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	B_home_terminal.getPServer()->setItsDefaultRequiredInterface(sip_Redirect.getPBh()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	sip_Redirect.getPA()->setItsDefaultRequiredInterface(A_terminal.getPServer()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	A_terminal.getPServer()->setItsDefaultRequiredInterface(sip_Redirect.getPA()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	C_terminal.getPDNS()->setItsIDNSLookupInitRes(initiator_and_dns.getPDNS_C()->getItsIDNSLookupInitRes());
    	
    }{
    	
    	initiator_and_dns.getPDNS_C()->setItsIDNSLookupResInit(C_terminal.getPDNS()->getItsIDNSLookupResInit());
    	
    }
    {
    	
    	B_work_terminal.getPDNS()->setItsIDNSLookupInitRes(initiator_and_dns.getPDNS_Bw()->getItsIDNSLookupInitRes());
    	
    }{
    	
    	initiator_and_dns.getPDNS_Bw()->setItsIDNSLookupResInit(B_work_terminal.getPDNS()->getItsIDNSLookupResInit());
    	
    }
    {
    	
    	B_work_terminal.getPC()->setItsDefaultRequiredInterface(C_terminal.getPBw()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	C_terminal.getPBw()->setItsDefaultRequiredInterface(B_work_terminal.getPC()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	B_work_terminal.getPA()->setItsDefaultRequiredInterface(A_terminal.getPBw()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	A_terminal.getPBw()->setItsDefaultRequiredInterface(B_work_terminal.getPA()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	B_home_terminal.getPDNS()->setItsIDNSLookupInitRes(initiator_and_dns.getPDNS_Bh()->getItsIDNSLookupInitRes());
    	
    }{
    	
    	initiator_and_dns.getPDNS_Bh()->setItsIDNSLookupResInit(B_home_terminal.getPDNS()->getItsIDNSLookupResInit());
    	
    }
    {
    	
    	B_home_terminal.getPC()->setItsDefaultRequiredInterface(C_terminal.getPBh()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	C_terminal.getPBh()->setItsDefaultRequiredInterface(B_home_terminal.getPC()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	A_terminal.getPDNS()->setItsIDNSLookupInitRes(initiator_and_dns.getPDNS_A()->getItsIDNSLookupInitRes());
    	
    }{
    	
    	initiator_and_dns.getPDNS_A()->setItsIDNSLookupResInit(A_terminal.getPDNS()->getItsIDNSLookupResInit());
    	
    }
    {
    	
    	A_terminal.getPBh()->setItsDefaultRequiredInterface(B_home_terminal.getPA()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	B_home_terminal.getPA()->setItsDefaultRequiredInterface(A_terminal.getPBh()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	A_terminal.getPC()->setItsDefaultRequiredInterface(C_terminal.getPA()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	C_terminal.getPA()->setItsDefaultRequiredInterface(A_terminal.getPC()->getItsDefaultProvidedInterface());
    	
    }
}

bool architectureSIP::startBehavior() {
    bool done = false;
    A_terminal.startBehavior();
    B_home_terminal.startBehavior();
    B_work_terminal.startBehavior();
    C_terminal.startBehavior();
    initiator_and_dns.startBehavior();
    sip_Redirect.startBehavior();
    done = OMReactive::startBehavior();
    return done;
}



#ifdef _OMINSTRUMENT


void OMAnimatedarchitectureSIP::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("initiator_and_dns", true, true);
    aomsRelations->ADD_ITEM(&myReal->initiator_and_dns);
    aomsRelations->addRelation("sip_Redirect", true, true);
    aomsRelations->ADD_ITEM(&myReal->sip_Redirect);
    aomsRelations->addRelation("B_home_terminal", true, true);
    aomsRelations->ADD_ITEM(&myReal->B_home_terminal);
    aomsRelations->addRelation("C_terminal", true, true);
    aomsRelations->ADD_ITEM(&myReal->C_terminal);
    aomsRelations->addRelation("B_work_terminal", true, true);
    aomsRelations->ADD_ITEM(&myReal->B_work_terminal);
    aomsRelations->addRelation("A_terminal", true, true);
    aomsRelations->ADD_ITEM(&myReal->A_terminal);
}

IMPLEMENT_REACTIVE_META_SIMPLE(architectureSIP, sip, false, OMAnimatedarchitectureSIP)
#endif // _OMINSTRUMENT


/*********************************************************************
	File Path	: DefaultComponent/DefaultConfig/architectureSIP.cpp
*********************************************************************/

